unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, oledrop,
  ComCtrls, StdCtrls;

type

  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    ListBox1: TListBox;
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FormDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
  private
    FWCDropTarget : IWCDroptarget;
  public
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

procedure TForm1.FormDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  if Source is ToleDragObject then
    begin
      StatusBar1.Panels[0].Text := 'Ole DragOver X:'+IntToStr(x)+' Y:'+IntToStr(Y);
      accept := TRUE;
    end;
end;

procedure TForm1.FormDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Source is ToleDragObject then
    begin
      StatusBar1.Panels[0].Text := 'Ole DragDrop X:'+IntToStr(x)+' Y:'+IntToStr(Y);
      ListBox1.items.AddStrings(ToleDragObject(source).FileList);
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FWCDropTarget := IWCDroptarget.Create(listbox1);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FWCDropTarget.Free;
end;

procedure TForm1.ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  if Source is ToleDragObject then
    begin
      StatusBar1.Panels[0].Text := '(Listbox) Ole DragOver X:'+IntToStr(x)+' Y:'+IntToStr(Y);
      accept := TRUE;
    end;
end;

procedure TForm1.ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Source is ToleDragObject then
    begin
      StatusBar1.Panels[0].Text := '(Listbox) Ole DragDrop X:'+IntToStr(x)+' Y:'+IntToStr(Y);
      ListBox1.items.AddStrings(ToleDragObject(source).FileList);
    end;
end;

end.
